#
# DATA FILE TO STORE VALUES ABOUT LDAP_TREE
# 


# Para optimizar las búsquedas seleccionando sólo el subárbol adecuado
# Cualquiera de estas variables se puede concatenar delante de LDAP_BASE_DN
LDAP_STUDENTS="ou=Students,ou=People,"  # Para buscar alumnos
LDAP_TEACHERS="ou=Teachers,ou=People,"  # Para buscar profesores
LDAP_OTHER="ou=Other,ou=People,"   # Para buscar en Other
LDAP_PEOPLE="ou=People,"      # Por si no se especifica el tipo de cuenta
LDAP_GROUPS="ou=Group,"            # Para buscar grupos

#########
# Mostrar el atributo indicado (o todos los atributos si no se indica cuál) de un usuario
# Confirmar si se debe usar validación simple (opción -x)
#########

case
     student)  LDAP_BASE_PREFIX="$LDAP_STUDENTS" ;;
     teacher)  LDAP_BASE_PREFIX="$LDAP_TEACHERS" ;;
     other)    LDAP_BASE_PREFIX="$LDAP_OTHER" ;;
     all)      LDAP_BASE_PREFIX="$LDAP_PEOPLE" ;;
esac

ldapsearch -x -LLL -H "$LDAP_URI" -b "$LDAP_BASE_PREFIX$LDAP_BASE_DN" "(&(objectClass=posixAccount)(uid=$UID))" $ATRIBUTO

#    $UID      -->  uid de la cuenta (usuario). Debería ser un parámetro posicional.
#    $ATRIBUTO -->  atributo(s) a mostrar del uid indicado. Deberían pasarse como parámetro. Valores útiles:
#
#         uidNumber
#         cn
#         sabayonProfile
#         home
#         gidNumber
#
#    NOTA: Devuelve siempre la línea dn (distinguished name) de la cuenta y, en líneas sucesivas, los atributos seleccionados.
#          Faltaría pasarlo por el sed como se hace después en las consultas sobre grupos.


########
# Mostrar la lista de grupos a los que pertenece un usuario (identificado por su uid)
########

ldapsearch -x -LLL -H $LDAP_URI -b "$LDAP_GROUPS$LDAP_BASE_DN" "(&(objectClass=posixGroup)(memberUid=$UID))" cn | sed -n "s/^cn: //p"


########
# Mostrar la lista de usuarios que pertenecen a un grupo (identificado por su gid)
########

ldapsearch -x -LLL -H $LDAP_URI -b "$LDAP_GROUPS$LDAP_BASE_DN" "(&(objectClass=posixGroup)(cn=$GID))" memberUid | sed -n "s/^memberUid: //p"


########
# Indica cuántos usuarios pertenecen a un grupo (identificado por su gid)
########

ldapsearch -x -LLL -H $LDAP_URI -b "$LDAP_GROUPS$LDAP_BASE_DN" "(&(objectClass=posixGroup)(cn=$GID))" memberUid | sed -n "s/^memberUid: //p" | wc -l


